-- delete the configuration of the old module
SET @tmp=0;
SELECT (@tmp:=configuration_group_id) as tmp FROM configuration_group WHERE configuration_group_title= 'Magic Scroll';
DELETE FROM configuration WHERE configuration_group_id = @tmp AND configuration_group_id != 0 and configuration_group_id IS NOT NULL;
DELETE FROM configuration_group WHERE configuration_group_id = @tmp AND configuration_group_id != 0 and configuration_group_id IS NOT NULL;

-- create config table
DROP TABLE IF EXISTS magicscroll_configuration;
CREATE TABLE magicscroll_configuration (
    `id` int unsigned NOT NULL auto_increment,
    `block` varchar(64) NOT NULL,
    `name` varchar(64) NOT NULL,
    `value` text,
    `default_value` text,
    `enabled` tinyint(1) unsigned NOT NULL,
    `default_enabled` tinyint(1) unsigned NOT NULL,
    PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- defaut config
INSERT INTO magicscroll_configuration (`block`, `name`, `value`, `default_value`, `enabled`,`default_enabled`) VALUES 
 ('default', 'thumb-max-width', '200', '200', 1, 1),
 ('default', 'thumb-max-height', '200', '200', 1, 1),
 ('default', 'square-images', 'disable', 'disable', 1, 1),
 ('default', 'width', 'auto', 'auto', 1, 1),
 ('default', 'height', 'auto', 'auto', 1, 1),
 ('default', 'orientation', 'horizontal', 'horizontal', 1, 1),
 ('default', 'mode', 'scroll', 'scroll', 1, 1),
 ('default', 'items', '3', '3', 1, 1),
 ('default', 'speed', '600', '600', 1, 1),
 ('default', 'autoplay', '0', '0', 1, 1),
 ('default', 'loop', 'infinite', 'infinite', 1, 1),
 ('default', 'step', 'auto', 'auto', 1, 1),
 ('default', 'arrows', 'inside', 'inside', 1, 1),
 ('default', 'pagination', 'No', 'No', 1, 1),
 ('default', 'easing', 'cubic-bezier(.8, 0, .5, 1)', 'cubic-bezier(.8, 0, .5, 1)', 1, 1),
 ('default', 'scrollOnWheel', 'auto', 'auto', 1, 1),
 ('default', 'lazy-load', 'No', 'No', 1, 1),
 ('default', 'scroll-extra-styles', '', '', 1, 1),
 ('default', 'show-image-title', 'No', 'No', 1, 1),
 ('default', 'link-to-product-page', 'Yes', 'Yes', 1, 1),
 ('default', 'imagemagick', 'off', 'off', 1, 1),
 ('default', 'image-quality', '75', '75', 1, 1),
 ('default', 'watermark', '', '', 1, 1),
 ('default', 'watermark-max-width', '30%', '30%', 1, 1),
 ('default', 'watermark-max-height', '30%', '30%', 1, 1),
 ('default', 'watermark-opacity', '50', '50', 1, 1),
 ('default', 'watermark-position', 'center', 'center', 1, 1),
 ('default', 'watermark-offset-x', '0', '0', 1, 1),
 ('default', 'watermark-offset-y', '0', '0', 1, 1),
 ('homeslideshow', 'enable-effect', 'No', 'No', 0, 0),
 ('homeslideshow', 'thumb-max-width', '200', '200', 1, 1),
 ('homeslideshow', 'thumb-max-height', '200', '200', 1, 1),
 ('homeslideshow', 'width', 'auto', 'auto', 0, 0),
 ('homeslideshow', 'height', 'auto', 'auto', 0, 0),
 ('homeslideshow', 'orientation', 'horizontal', 'horizontal', 0, 0),
 ('homeslideshow', 'mode', 'scroll', 'scroll', 0, 0),
 ('homeslideshow', 'items', '3', '3', 0, 0),
 ('homeslideshow', 'speed', '600', '600', 0, 0),
 ('homeslideshow', 'autoplay', '0', '0', 0, 0),
 ('homeslideshow', 'loop', 'infinite', 'infinite', 0, 0),
 ('homeslideshow', 'step', 'auto', 'auto', 0, 0),
 ('homeslideshow', 'arrows', 'inside', 'inside', 1, 1),
 ('homeslideshow', 'pagination', 'No', 'No', 0, 0),
 ('homeslideshow', 'easing', 'cubic-bezier(.8, 0, .5, 1)', 'cubic-bezier(.8, 0, .5, 1)', 0, 0),
 ('homeslideshow', 'scrollOnWheel', 'auto', 'auto', 0, 0),
 ('homeslideshow', 'lazy-load', 'No', 'No', 0, 0),
 ('homeslideshow', 'scroll-extra-styles', '', '', 0, 0),
 ('homeslideshow', 'show-image-title', 'No', 'No', 0, 0),
 ('homeslideshow', 'link-to-product-page', 'Yes', 'Yes', 0, 0),
 ('product', 'enable-effect', 'Yes', 'Yes', 1, 1),
 ('product', 'thumb-max-width', '200', '200', 0, 0),
 ('product', 'thumb-max-height', '200', '200', 0, 0),
 ('product', 'width', 'auto', 'auto', 0, 0),
 ('product', 'height', 'auto', 'auto', 0, 0),
 ('product', 'orientation', 'horizontal', 'horizontal', 0, 0),
 ('product', 'mode', 'scroll', 'scroll', 0, 0),
 ('product', 'items', '3', '3', 0, 0),
 ('product', 'speed', '600', '600', 0, 0),
 ('product', 'autoplay', '0', '0', 0, 0),
 ('product', 'loop', 'infinite', 'infinite', 0, 0),
 ('product', 'step', 'auto', 'auto', 0, 0),
 ('product', 'arrows', 'inside', 'inside', 1, 1),
 ('product', 'pagination', 'No', 'No', 0, 0),
 ('product', 'easing', 'cubic-bezier(.8, 0, .5, 1)', 'cubic-bezier(.8, 0, .5, 1)', 0, 0),
 ('product', 'scrollOnWheel', 'auto', 'auto', 0, 0),
 ('product', 'lazy-load', 'No', 'No', 0, 0),
 ('product', 'scroll-extra-styles', '', '', 0, 0),
 ('product', 'show-image-title', 'No', 'No', 0, 0),
 ('new_products', 'enable-effect', 'No', 'No', 0, 0),
 ('new_products', 'thumb-max-width', '200', '200', 1, 1),
 ('new_products', 'thumb-max-height', '200', '200', 1, 1),
 ('new_products', 'width', 'auto', 'auto', 0, 0),
 ('new_products', 'height', 'auto', 'auto', 0, 0),
 ('new_products', 'orientation', 'horizontal', 'horizontal', 0, 0),
 ('new_products', 'mode', 'scroll', 'scroll', 0, 0),
 ('new_products', 'items', '3', '3', 0, 0),
 ('new_products', 'speed', '600', '600', 0, 0),
 ('new_products', 'autoplay', '0', '0', 0, 0),
 ('new_products', 'loop', 'infinite', 'infinite', 0, 0),
 ('new_products', 'step', 'auto', 'auto', 0, 0),
 ('new_products', 'arrows', 'inside', 'inside', 1, 1),
 ('new_products', 'pagination', 'No', 'No', 0, 0),
 ('new_products', 'easing', 'cubic-bezier(.8, 0, .5, 1)', 'cubic-bezier(.8, 0, .5, 1)', 0, 0),
 ('new_products', 'scrollOnWheel', 'auto', 'auto', 0, 0),
 ('new_products', 'lazy-load', 'No', 'No', 0, 0),
 ('new_products', 'scroll-extra-styles', '', '', 0, 0),
 ('new_products', 'show-image-title', 'No', 'No', 0, 0),
 ('new_products', 'link-to-product-page', 'Yes', 'Yes', 0, 0),
 ('whats_new', 'enable-effect', 'No', 'No', 0, 0),
 ('whats_new', 'thumb-max-width', '100', '100', 1, 1),
 ('whats_new', 'thumb-max-height', '100', '100', 1, 1),
 ('whats_new', 'width', 'auto', 'auto', 0, 0),
 ('whats_new', 'height', 'auto', 'auto', 0, 0),
 ('whats_new', 'orientation', 'vertical', 'vertical', 1, 1),
 ('whats_new', 'mode', 'scroll', 'scroll', 0, 0),
 ('whats_new', 'items', '3', '3', 0, 0),
 ('whats_new', 'speed', '600', '600', 0, 0),
 ('whats_new', 'autoplay', '0', '0', 0, 0),
 ('whats_new', 'loop', 'infinite', 'infinite', 0, 0),
 ('whats_new', 'step', 'auto', 'auto', 0, 0),
 ('whats_new', 'arrows', 'inside', 'inside', 0, 0),
 ('whats_new', 'pagination', 'No', 'No', 0, 0),
 ('whats_new', 'easing', 'cubic-bezier(.8, 0, .5, 1)', 'cubic-bezier(.8, 0, .5, 1)', 0, 0),
 ('whats_new', 'scrollOnWheel', 'auto', 'auto', 0, 0),
 ('whats_new', 'lazy-load', 'No', 'No', 0, 0),
 ('whats_new', 'scroll-extra-styles', '', '', 0, 0),
 ('whats_new', 'show-image-title', 'No', 'No', 0, 0),
 ('whats_new', 'link-to-product-page', 'Yes', 'Yes', 0, 0),
 ('specials', 'enable-effect', 'No', 'No', 0, 0),
 ('specials', 'thumb-max-width', '100', '100', 1, 1),
 ('specials', 'thumb-max-height', '100', '100', 1, 1),
 ('specials', 'width', 'auto', 'auto', 0, 0),
 ('specials', 'height', 'auto', 'auto', 0, 0),
 ('specials', 'orientation', 'vertical', 'vertical', 1, 1),
 ('specials', 'mode', 'scroll', 'scroll', 0, 0),
 ('specials', 'items', '3', '3', 0, 0),
 ('specials', 'speed', '600', '600', 0, 0),
 ('specials', 'autoplay', '0', '0', 0, 0),
 ('specials', 'loop', 'infinite', 'infinite', 0, 0),
 ('specials', 'step', 'auto', 'auto', 0, 0),
 ('specials', 'arrows', 'inside', 'inside', 0, 0),
 ('specials', 'pagination', 'No', 'No', 0, 0),
 ('specials', 'easing', 'cubic-bezier(.8, 0, .5, 1)', 'cubic-bezier(.8, 0, .5, 1)', 0, 0),
 ('specials', 'scrollOnWheel', 'auto', 'auto', 0, 0),
 ('specials', 'lazy-load', 'No', 'No', 0, 0),
 ('specials', 'scroll-extra-styles', '', '', 0, 0),
 ('specials', 'show-image-title', 'No', 'No', 0, 0),
 ('specials', 'link-to-product-page', 'Yes', 'Yes', 0, 0),
 ('reviews', 'enable-effect', 'No', 'No', 0, 0),
 ('reviews', 'thumb-max-width', '100', '100', 1, 1),
 ('reviews', 'thumb-max-height', '100', '100', 1, 1),
 ('reviews', 'width', 'auto', 'auto', 0, 0),
 ('reviews', 'height', 'auto', 'auto', 0, 0),
 ('reviews', 'orientation', 'vertical', 'vertical', 1, 1),
 ('reviews', 'mode', 'scroll', 'scroll', 0, 0),
 ('reviews', 'items', '3', '3', 0, 0),
 ('reviews', 'speed', '600', '600', 0, 0),
 ('reviews', 'autoplay', '0', '0', 0, 0),
 ('reviews', 'loop', 'infinite', 'infinite', 0, 0),
 ('reviews', 'step', 'auto', 'auto', 0, 0),
 ('reviews', 'arrows', 'inside', 'inside', 0, 0),
 ('reviews', 'pagination', 'No', 'No', 0, 0),
 ('reviews', 'easing', 'cubic-bezier(.8, 0, .5, 1)', 'cubic-bezier(.8, 0, .5, 1)', 0, 0),
 ('reviews', 'scrollOnWheel', 'auto', 'auto', 0, 0),
 ('reviews', 'lazy-load', 'No', 'No', 0, 0),
 ('reviews', 'scroll-extra-styles', '', '', 0, 0),
 ('reviews', 'show-image-title', 'No', 'No', 0, 0),
 ('reviews', 'link-to-product-page', 'Yes', 'Yes', 0, 0),
 ('default', 'version', '4.9.1', '4.9.1', 1, 1);

-- create images table
CREATE TABLE IF NOT EXISTS magicscroll_images (
    `id` int unsigned NOT NULL auto_increment,
    `name` varchar(256) NOT NULL,
    `title` varchar(256) DEFAULT '',
    `description` text,
    `link` varchar(256) DEFAULT '',
    `image_order` int unsigned DEFAULT 0,
    `exclude` tinyint(1) unsigned DEFAULT 0,
    PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
